clear;      %clearing data analysis

dir='D:\teleRadio Documentation\Heart beat documentation\2005-01-26 Seismeter sensor data analysis\test signal acquisition data file\2- converted text PLW file\';
file_ext='.PLW';

file0='sensor hand0';
file0='scope 100Hz signal';
file1='scope 1Hz signal';

file0='scope 100Hz signal';
file0='scope 10Hz signal';
file0='scope 1Hz signal';
file0='sensor nulling0';
file0='sensor nulling1';
file0='sensor nulling2';
file0='sensor nulling3';
file0='sensor nulling4';
file0='sensor hand0';
file0='sensor hand1';
file0='sensor hand2';
file0='sensor hand3';
file0='sensor hand4';
file0='armrest hand0';
file0='armrest hand1';
file0='armrest hand2';
file0='armrest hand3';
file0='armrest hand4';
file0='armrest nulling0';
file0='armrest nulling1';
file0='armrest nulling2';
file0='armrest nulling4';
file0='ruler hand0';
file0='ruler hand1';
file0='ruler hand2';
file0='ruler hand3';
%XXXfile0='ruler hand4';reading=8.176039212335656e+006
file0='platform nulling0';
file0='platform nulling1';
file0='platform nulling2';
file0='platform nulling3';
file0='platform nulling4';%11.33202882814038
%XXXfile0='platform hand0';6.916590778334565e+002
%XXXfile0='platform hand1';7.936378680164505e+002
%XXXfile0='platform hand2';3.448471682278633e+002
%XXXfile0='platform hand3';1.628731245828846e+003
%XXXfile0='platform hand4';2.395823015165295e+002
%XXXfile0='platform rubber hand0';5.431378312157412e+002
%file0='platform rubber hand1';
%file0='platform rubber hand2';
%file0='platform rubber hand3';
%file0='platform rubber hand4';
file0='platform 2x hand0';%1.220463660274052e+003
%file0='platform 2x hand1';
%file0='platform 2x hand2';
%file0='platform 2x hand3';
%file0='platform 2x hand4';
%file0='gnd platform bare foot0';
%file0='gnd platform bare foot1';
%file0='gnd platform bare foot2';
%file0='gnd platform bare foot3';
file0='gnd platform nulling0';%2.90910006570021
file0='gnd platform nulling1, bare foot';
%file0='gnd platform nulling2, palm';
%file0='gnd platform nulling3, shoe';
%file0='gnd platform nulling4, sit';
%file0='gnd platform palm0';
%file0='gnd platform palm1';
%file0='gnd platform palm2';
%file0='gnd platform palm3';
%file0='gnd platform palm4';
%file0='gnd platform shoe0';
%file0='gnd platform shoe1';
%file0='gnd platform shoe2';
%file0='gnd platform shoe3';
%file0='gnd platform shoe4';
%file0='gnd platform sit0';
%file0='gnd platform sit1';
%file0='gnd platform sit2';
%file0='gnd platform sit3';
%file0='gnd platform sit4';
%file0='car foam hand0';
%file0='car foam hand1';
%file0='car foam hand2';
%file0='car foam hand3';
%file0='car foam hand4';
%file0='car foam hand nulling0';
%file0='car foam hand nulling1';
%file0='car foam hand nulling2';
%file0='car foam hand nulling3';
%file0='car foam hand nulling4';
%file0='car handfar0';
%file0='car handfar1';
%file0='car handfar2';
%file0='car handfar3';
%file0='car handfar4';
%file0='car handnear0';
%file0='car handnear1';
%file0='car handnear2';
%file0='car handnear3';
%file0='car handnear4';
%file0='car inside seat0';
%file0='car inside seat1';
%file0='car inside seat3';
%file0='car inside seat4';
%file0='car laying back0';
%file0='car laying back1';
%file0='car laying back2';
%file0='car laying back3';
%file0='car laying back4';
%file0='car laying front0';
%file0='car laying front1';
%file0='car laying front2';
%file0='car laying front3';
%file0='car laying front4';
%file0='car nulling3';
%file0='car nulling4';
%file0='car nulling10';
%file0='car nulling11';
%file0='car nulling12';
%file0='car nulling13';
%file0='car nulling14';
%file0='car nulling20';
%file0='car nulling21';
%file0='car nulling22';
%file0='car nulling23';
%file0='car nulling24';
%file0='car on0';
%file0='car on1';
%file0='car on2';
%file0='car on3';
%file0='car on4';
%file0='car on person0';
%file0='car on person1';
%file0='car on person2';
%file0='car on person3';
%file0='car on person4';
%file0='car palm0';
%file0='car palm1';
%file0='car palm2';
%file0='car palm3';
%file0='car palm4';
%file0='car sit0';
%file0='car sit1';
%file0='car sit2';
%file0='car sit3';
%file0='car sit4';
mode=0;

%Loading data from the following format, example
%0		22.39
%54		22.46
%108	22.52   ...etc
%signal 0, voltage acquisition
[timestamp0,voltage0]=textread(strcat(dir,file0,file_ext),'%d %f',-1);

[timestamp1,voltage1]=textread(strcat(dir,file1,file_ext),'%d %f',-1);
%voltage0=voltage0+voltage1;

sampling_duration=5.500032; %sampling during in seconds
sample_num=100000;          %number of sample taken within the sampling duration
duration_per_sample=sampling_duration/sample_num;
fs=sample_num/sampling_duration;   %sampling frequency
time=duration_per_sample:duration_per_sample:5.500032;  %sample is not taken at time=0


%Implementing the filter%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Chebyshev Type 1 order 1, fs=18kHz fc=50Hz LPF filter
%den=[1.0e+002 0.01000000000000 -0.09983253262721 0.44850178570450 -1.19404299434129 2.08618370415941 -2.49940023218540 2.07952451219543 -1.18643226693666 0.44422054312114 -0.09856392984548 0.00984141075557];
%num=[1.0e-014 -0.00329507005344 -0.03295070053438 -0.14827815240473 -0.39540840641260 -0.69196471122205 -0.83035765346646 -0.69196471122205 -0.39540840641260 -0.14827815240473 -0.03295070053438 -0.00329507005344];
%voltagef=filter(num,den,voltage0);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
voltagef=voltage1;


%Signal FFT%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
freq_size=512*1000;
max_signal_freq=0.5*fs;
freq_resolution=fs/freq_size;
freq_range=freq_resolution:freq_resolution:fs;

%frequency spectrum of signal 0
freq_magnitude0=fft(voltage0,freq_size);
Pyy0=freq_magnitude0.*conj(freq_magnitude0)/freq_size;
spectrum0=Pyy0;
%frequency spectrum of signal 1
freq_magnitudef=fft(voltagef,freq_size);
Pyyf=freq_magnitudef.*conj(freq_magnitudef)/freq_size;
spectrumf=Pyyf;

%Signal Display%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%plot signal time domain, before & after filtering
displayrange0=[0 0.500032 -300 300]; %graph display limit
displayrangef=[0 0.500032 -10 10]; %graph display limit

%frequency magnitude scaling
displayfreqrange0=[0 25 0 6e6]; %graph display limit
displayfreqrangef=[0 25 0 6e6]; %graph display limit
freqrangegain=[1 1 0 0]+0.5*[0 0 1 1]; %graph display limit
displayfreqrange0=displayfreqrange0.*freqrangegain;
displayfreqrangef=displayfreqrangef.*freqrangegain;

if(mode==1)
subplot(2,2,1);
plot(time,voltage0);
%axis(displayrange0);     %time graph view
title('signal');
subplot(2,2,3);
plot(time,voltagef);
%axis(displayrangef);     %time graph view
title('filtered signal');

subplot(2,2,2);
plot(freq_range,spectrum0);
axis(displayfreqrange0);
title('spectrum');
subplot(2,2,4);
plot(freq_range,spectrumf);
axis(displayfreqrangef);
title('fitered spectrum');
end

%Detection algorithm
fL=1;   %lower cutoff freq
fH=11;   %higher cutoff freq
indexfL=round(fL/freq_resolution);
indexfH=round(fH/freq_resolution);
ans=sum(spectrum0(indexfL:indexfH))

if(ans>1e+007)  %highest nulling= 1.191500887750980e+007
    detect='Detected';
else
    detect='NOT detected';
end

Analysis_Result=sprintf('file:         %s%s\nResult >>     %s',file0,file_ext,detect)

